// EhhevtView.cpp : implementation of the CEhhevtView class
//

#include "stdafx.h"
#include "Ehhevt.h"
#include "mainfrm.h"
#include "EhhevtDoc.h"
#include "EhhevtView.h"
#include "sqlstmt.h"
#include "math.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
/////////////////////////////////////////////////////////////////////////////
// CEhhevtView

IMPLEMENT_DYNCREATE(CEhhevtView, CView)

BEGIN_MESSAGE_MAP(CEhhevtView, CView)
	//{{AFX_MSG_MAP(CEhhevtView)
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
	// Standard printing commands
	
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(IDI_ICON2/*ID_FILE_PRINT_PREVIEW*/, CView::OnFilePrintPreview)
	ON_COMMAND(MAKELONG(10001, BN_CLICKED), OnGridSizingCol)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEhhevtView construction/destruction

CEhhevtView::CEhhevtView()
{
	// TODO: add construction code here
    m_nCols = 0;
	m_nRows = 0;
	m_nFixCols = 1;
	m_nFixRows = 1;
//	m_pOldFrame =NULL;
	m_pGridCtrl = NULL;
}

CEhhevtView::~CEhhevtView()
{
	if (m_pGridCtrl)
	{
		delete m_pGridCtrl;
		m_pGridCtrl = NULL;
	}
}

BOOL CEhhevtView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CEhhevtView drawing

void CEhhevtView::OnDraw(CDC* pDC)
{
	CEhhevtDoc* pDoc =(CEhhevtDoc*) GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here
}

/////////////////////////////////////////////////////////////////////////////
// CEhhevtView printing

BOOL CEhhevtView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation

	return DoPreparePrinting(pInfo);
}
void CEhhevtView::OnPrint(CDC* pDC, CPrintInfo* pInfo) 
{
	if (m_pGridCtrl)
		m_pGridCtrl->OnPrint(pDC, pInfo);
}
void CEhhevtView::OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo)
{
	// TODO: add extra initialization before printing
	if (m_pGridCtrl)
		m_pGridCtrl->OnBeginPrinting(pDC, pInfo);
}

void CEhhevtView::OnEndPrinting(CDC* pDC, CPrintInfo *pInfo)
{
	// TODO: add cleanup after printing
	if (m_pGridCtrl)
		m_pGridCtrl->OnEndPrinting(pDC, pInfo);
	

}

/////////////////////////////////////////////////////////////////////////////
// CEhhevtView diagnostics

#ifdef _DEBUG
void CEhhevtView::AssertValid() const
{
	CView::AssertValid();
}

void CEhhevtView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}


#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CEhhevtView message handlers
void CEhhevtView::OnInitialUpdate() 
{
	CView::OnInitialUpdate();
	InitAllData();
	// TODO: Add your specialized code here and/or call the base class
	if (m_pGridCtrl == NULL)
	{
		// Create the Gridctrl object
		m_pGridCtrl = new CGridCtrl;
		if (!m_pGridCtrl) return;

		// Create the Gridctrl window
		CRect rect;
		GetClientRect(rect);
		m_pGridCtrl->Create(rect, this, 10001);

	    m_pGridCtrl->SetRowResize(FALSE);

	m_pGridCtrl->SetVirtualMode(FALSE);
	m_pGridCtrl->SetEditable(FALSE);

	m_pGridCtrl->SetFixedRowSelection(TRUE);
	m_pGridCtrl->SetListMode(TRUE);
	m_pGridCtrl->EnableHiddenColUnhide(FALSE);


	m_pGridCtrl->SetHeaderSort(TRUE);
	m_pGridCtrl->SetCompareFunction(CGridCtrl::pfnCellNumericCompare);

	CFont * editFont = m_pGridCtrl->GetFont();
	LOGFONT lf;
	editFont->GetLogFont(&lf);
	lf.lfHeight = -13;
	strcpy(lf.lfFaceName, "΢ź");
	m_editFont.CreateFontIndirect(&lf);
	m_pGridCtrl->SetFont(&m_editFont);

	InitGridHead();
	}

}

void CEhhevtView::OnSize(UINT nType, int cx, int cy) 
{
	CView::OnSize(nType, cx, cy);
	
	// TODO: Add your message handler code here
	CRect rc;
	GetClientRect(rc);

	if(m_pGridCtrl->GetSafeHwnd())
	{
	   m_pGridCtrl->MoveWindow(rc);
	}
}

BOOL CEhhevtView::InitGridHead()//ͷ
{	//WYF 20180719 alarmset.ini-[] 
	CEhhevtApp *pApp =(CEhhevtApp *)AfxGetApp();
	CReadConf cfg;
	char szName[32]="";	//WYF 20180719
     try
	{
		m_pGridCtrl->SetRowCount(m_nRows+1);
		m_pGridCtrl->SetColumnCount(m_nCols+1);
		m_pGridCtrl->SetFixedRowCount(m_nFixRows);
		m_pGridCtrl->SetFixedColumnCount(m_nFixCols);
	}
	catch (CMemoryException* e)
	{
		e->ReportError();
		e->Delete();
		return FALSE;
	}

	for (int i = 0; i < m_nCols; i++)
	{
		GV_ITEM Item;
		
		Item.mask = GVIF_TEXT;
		Item.row = 0;
		Item.col = i+1;
		//WYF 20180719 alarmset.ini-[] 
		//cfg.ReadString("", m_colType[i].szName, szName, pApp->m_szCfgPath, m_colType[i].szName);
		Item.strText.Format("%s", m_colType[i].szDesc);//WYF 20180719 m_colType[i].szName);
		m_pGridCtrl->SetItem(&Item);
	}

	SetAllColWidth();

	return TRUE;
}

void CEhhevtView::SetAllColWidth()//col
{
    m_pGridCtrl->SetColumnWidth(0, 50);//30;wyf 20181102̶п
	for(int i = 0; i < m_nCols; i++)
	{
		long lWidth = m_colType[i].lWidth;
		if(m_colType[i].bSet)
			m_pGridCtrl->SetColumnWidth(i+1, lWidth);
		else
			m_pGridCtrl->SetColumnWidth(i+1, 0);
	}
}

BOOL CEhhevtView::InitAllData()
{
	CSE_DBOption dbo;

    if (dbo.BeginSelectRcdSet(SQL_ALMH_FLD) != SEDB_SUCCESS)   
		return FALSE;
    CEhhevtApp *pApp =(CEhhevtApp *)AfxGetApp();
	CReadConf cfg;
	COLTYPE ct;
	char szWidth[MAX_PATH];
	char width[10];
	short datalen;
	char nameDefine[2][32] = { "Ƿȷ", "Ƿָ" };

	m_nCols = dbo.GetRcdCount();
	m_nCols += 2;	//+2ʾnameDefine
	m_colType.SetSize(m_nCols);
	for (int i = 0; i < m_nCols-2; i++) 
	{
		strcpy(ct.szName, dbo.GetStringVal(i, 0));
		int index = cfg.ReadLong("ColSequence",ct.szName,pApp->m_szCfgPath,0);
		
		datalen = dbo.GetShortVal(i, 1);
		sprintf(szWidth, "%s", ct.szName);
		sprintf(width, "%d", datalen > 0 ? min(datalen, 64) * 8 : 64);
		ct.lWidth = cfg.ReadLong("History", szWidth, pApp->m_szCfgPath, width);
		ct.bSet = cfg.ReadLong("History", ct.szName, pApp->m_szCfgPath, "0") != 0;
		cfg.ReadString("ʷ", ct.szName, ct.szDesc, pApp->m_szCfgPath, ct.szName);
		m_colType[index] = ct;
	}
	for (i = 0; i < 2; i++)
	{
		
		strcpy(ct.szName, nameDefine[i]);
		int index = cfg.ReadLong("ColSequence", ct.szName, pApp->m_szCfgPath, 0);	//֧ظ
		sprintf(szWidth, "%s", ct.szName);
		ct.lWidth = cfg.ReadLong("History", szWidth, pApp->m_szCfgPath, "64");
		ct.bSet = cfg.ReadLong("History", ct.szName, pApp->m_szCfgPath, "0") != 0;
		cfg.ReadString("ʷ", ct.szName, ct.szDesc, pApp->m_szCfgPath, nameDefine[i]);
		
		m_colType[index] = ct;
	}

	dbo.EndSelectRcdSet();
    return TRUE;
}


/*BOOL CEhhevtView::InitAllData()
{
	CSE_DBOption dbo;

    if (dbo.BeginSelectRcdSet(SQL_ALMH_FLD) != SEDB_SUCCESS)   
		return FALSE;
    CEhhevtApp *pApp =(CEhhevtApp *)AfxGetApp();
	CReadConf cfg;
	COLTYPE ct;
	char szWidth[MAX_PATH];
	char width[10];
	short datalen;

	m_nCols = dbo.GetRcdCount();

	m_colType.SetSize(m_nCols);
	for (int i = 0; i < m_nCols; i++)
	{
		strcpy(ct.szName, dbo.GetStringVal(i, 0));
		datalen = dbo.GetShortVal(i, 1);

		sprintf(szWidth, "%s", ct.szName);
		sprintf(width, "%d", datalen > 0 ? min(datalen, 64) * 8 : 64);
		ct.lWidth = cfg.ReadLong("History", szWidth, pApp->m_szCfgPath, width);
		ct.bSet = cfg.ReadLong("History", ct.szName, pApp->m_szCfgPath, "1") != 0;
		m_colType[i] = ct;
	}

	dbo.EndSelectRcdSet();
    return TRUE;
}*/

void CEhhevtView::RefreshGrid()//к
{
    long lCount = m_pGridCtrl->GetRowCount();

	CString str;
	for(long l = 1; l < lCount; l++)
	{
		str.Format("%d", l);
		m_pGridCtrl->SetItemText(l, 0, str);
	}
}

void CEhhevtView::OnGridSizingCol()
{
	long lWidth;
	char szKey[MAX_PATH];
	char szWidth[MAX_PATH];

	int nCol = m_colType.GetSize();
	for(int i = 1; i <= nCol; i++)
	{
		if (!m_colType[i-1].bSet)
			continue;

		lWidth = m_pGridCtrl->GetColumnWidth(i);
		if (m_colType[i-1].lWidth == lWidth)
			continue;

		m_colType[i-1].lWidth = lWidth;

		sprintf(szKey, "%s", m_colType[i-1].szName);
		sprintf(szWidth, "%d", lWidth);
		::WritePrivateProfileString("History", szKey, szWidth, g_pApp->m_szCfgPath);
	}
}
