// EhhevtView.h : interface of the CEhhevtView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_EHHEVTVIEW_H__ABF4C75F_3A97_4ACA_9606_F1AAC939A8C3__INCLUDED_)
#define AFX_EHHEVTVIEW_H__ABF4C75F_3A97_4ACA_9606_F1AAC939A8C3__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include "Public.h"
#include "GridCtrl_src/GridCtrl.h"

class CEhhevtView : public CView
{
protected: // create from serialization only
	CEhhevtView();
	DECLARE_DYNCREATE(CEhhevtView)

// Attributes
public:
	
//    CMainFrame* m_pOldFrame;
// Operations
public:
    CGridCtrl* m_pGridCtrl;

	int m_nCols ;
	int m_nRows ;
	int	m_nFixCols;
	int	m_nFixRows;
	CArray<COLTYPE, COLTYPE&> m_colType;
	// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CEhhevtView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnInitialUpdate();
	virtual void OnPrint(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	void RefreshGrid();
	BOOL InitAllData();
	void SetAllColWidth();
	BOOL InitGridHead();
	virtual ~CEhhevtView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif
protected:
#ifndef _DEBUG  // debug version in EhhevtView.cpp
	CEhhevtDoc* GetDocument();
#endif

// Generated message map functions
protected:
	//{{AFX_MSG(CEhhevtView)
	afx_msg void OnGridSizingCol();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	CFont m_editFont;
};

#ifndef _DEBUG  // debug version in EhhevtView.cpp
inline CEhhevtDoc* CEhhevtView::GetDocument()
   { return (CEhhevtDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_EHHEVTVIEW_H__ABF4C75F_3A97_4ACA_9606_F1AAC939A8C3__INCLUDED_)
