// GridPage.cpp : implementation file
//

#include "stdafx.h"
#include "Ehhevt.h"
#include "GridPage.h"
#include "sqlstmt.h"
#include "MainFrm.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGridPage property page

IMPLEMENT_DYNCREATE(CGridPage, CPropertyPage)

CGridPage::CGridPage(CWnd* pParent /*=NULL*/)
	: CPropertyPage(CGridPage::IDD)
{
	//{{AFX_DATA_INIT(CGridPage)
	m_lCount = 0;
	m_lLimitCount = 0;
	//}}AFX_DATA_INIT
	m_psp.dwFlags &= ~PSP_HASHELP;
	m_pDlg = ( CToolView *)pParent;

	m_lCount = m_pDlg->m_lCount;
	m_lLimitCount = m_pDlg->m_lLimitCount;
}

CGridPage::~CGridPage()
{
}

void CGridPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGridPage)
	DDX_Control(pDX, IDC_COLLIST, m_lstCol);
	DDX_Text(pDX, IDC_EDITCOUNT, m_lCount);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CGridPage, CPropertyPage)
	//{{AFX_MSG_MAP(CGridPage)
	ON_COMMAND(ID_MOVEUP, OnMoveup)
	ON_COMMAND(ID_MOVEDOWN, OnMovedown)
	ON_COMMAND(ID_MOVETOTOP, OnMovetotop)
	ON_COMMAND(ID_MOVETOEND, OnMovetoend)
	ON_COMMAND(ID_DEFAULT, OnDefault)
	ON_UPDATE_COMMAND_UI(ID_MOVEUP, OnUpdateMoveup)
	ON_UPDATE_COMMAND_UI(ID_MOVETOTOP, OnUpdateMovetotop)
	ON_UPDATE_COMMAND_UI(ID_MOVEDOWN, OnUpdateMovedown)
	ON_UPDATE_COMMAND_UI(ID_MOVETOEND, OnUpdateMovetoend)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGridPage message handlers

BOOL CGridPage::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();

	if (!m_wndToolBar1.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE
		| CBRS_ALIGN_RIGHT | CBRS_TOOLTIPS | CBRS_FLYBY) ||
		!m_wndToolBar1.LoadToolBar(IDR_TOOLBAR))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	// And position the control bars
	RepositionBars(AFX_IDW_CONTROLBAR_FIRST, AFX_IDW_CONTROLBAR_LAST, 0);

	CRect rect1;
	m_lstCol.GetWindowRect(&rect1);
	ScreenToClient(&rect1);

	CRect rect2;
	m_wndToolBar1.GetWindowRect(&rect2);
	ScreenToClient(&rect2);

	int width = rect2.Width();
	int height = rect2.Height();
	rect2.top = rect1.top + 45;
	rect2.bottom = rect2.top + height;
	rect2.left = rect1.right + 50;
	rect2.right = rect2.left + width;

	m_wndToolBar1.MoveWindow(&rect2);

	// TODO: Add extra initialization here
	CMainFrame* pFrmae =(CMainFrame*)g_pApp->m_pMainWnd;
	CEhhevtView* pView =pFrmae->GetView();
	m_ImageList.Create(IDB_STATEICONS, 16, 1, RGB(255, 0, 0));
	m_lstCol.SetImageList(&m_ImageList, LVSIL_STATE);
		
	m_lstCol.InsertColumn(0, "", LVCFMT_LEFT, 120);
	m_lstCol.InsertColumn(1, "п", LVCFMT_LEFT, 60);

	if(m_pDlg == NULL)
		return FALSE;

	int nCol = m_pDlg->m_nCols;

	LV_ITEM lvi;
	lvi.mask = LVIF_TEXT | LVIF_STATE;
	for(int i = 0; i < nCol; i++)
	{
		lvi.iItem = i;
		lvi.iSubItem = 0;
		lvi.pszText = pView->m_colType[i].szName;
		lvi.stateMask = LVIS_STATEIMAGEMASK;
		if(pView->m_colType[i].bSet)
			lvi.state = INDEXTOSTATEIMAGEMASK(2);
		else
			lvi.state = INDEXTOSTATEIMAGEMASK(1);

		m_lstCol.InsertItem(&lvi);

		CString sz;
		sz.Format("%d", pView->m_colType[i].lWidth);
		m_lstCol.SetItemText(i, 1, sz);
	}

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CGridPage::OnOK() 
{
	UpdateData();
    CMainFrame* pFrmae =(CMainFrame*)g_pApp->m_pMainWnd;
	if(::GetFileAttributes(g_pApp->m_szCfgPath) & FILE_ATTRIBUTE_READONLY)
	{
		::SetFileAttributes(g_pApp->m_szCfgPath, FILE_ATTRIBUTE_NORMAL);
	}

	CReadConf cfg;

	//++++char *tmp;
	//++++tmp = new char[MAX_PATH];
	char buf[1024];
	memset(buf,0,1024);
	int pos = 0;

	for(int i = 0; i < m_lstCol.GetItemCount(); i++)
	{	
		UINT uState = m_lstCol.GetItemState(i, LVIS_STATEIMAGEMASK);
		CString sz = m_lstCol.GetItemText(i, 0);

		CString strset,stritem;
		
		if((uState >> 12) == 1)		// δѡ
		{
			pFrmae->GetView()->m_colType[i].bSet = false;
			strset = "0";
		}
		else
		{
			pFrmae->GetView()->m_colType[i].bSet = true;
			strset = "1";
		}
		stritem += sz;
		stritem += "=";
		stritem += strset;
		stritem += '\0';	
		char *p = (LPSTR)(LPCSTR)sz;
		strcpy(pFrmae->GetView()->m_colType[i].szName,p);

		


		long lWidth = atol(m_lstCol.GetItemText(i, 1));
		

		CString strWidth;
		strWidth.Format("%d",lWidth);

		stritem += sz;
		stritem += "=";
		stritem += strWidth;
		char *tmp = stritem.GetBuffer(0);
		memcpy(buf+pos,tmp,stritem.GetLength());
		pos += stritem.GetLength() + 1;	
		
		pFrmae->GetView()->m_colType[i].lWidth = lWidth;
		cfg.WriteLong("ColSequence", p, i, g_pApp->m_szCfgPath);
	}

	WritePrivateProfileSection("History",buf,g_pApp->m_szCfgPath);

	cfg.WriteLong("History", "MaxCount", m_lCount, g_pApp->m_szCfgPath);
	m_pDlg->m_lCount = m_lCount;
	
	cfg.WriteLong("History", "LimitCount", m_lLimitCount, g_pApp->m_szCfgPath);
	m_pDlg->m_lLimitCount = m_lLimitCount;
	CEhhevtView* pView =pFrmae->GetView();
	pView->InitGridHead();
    CToolView* pToolView =(CToolView*)pFrmae->GetExView();
	if(pToolView->IsAlreadyQueryed){
		pToolView->OnQuery();
	}
}

void CGridPage::OnMoveup() 
{	
	CMainFrame* pFrmae = (CMainFrame*)g_pApp->m_pMainWnd;
	CEhhevtView* pView = pFrmae->GetView();
//	int nItem ;
	
	for(int i=0; i<m_lstCol.GetItemCount(); i++)
	{
		if(m_lstCol.GetItemState(i, LVIS_SELECTED) == LVIS_SELECTED)
		{	
			nItem=i;
			break;
		}
		if(i == m_lstCol.GetItemCount() - 1 && m_lstCol.GetItemState(i, LVIS_SELECTED) != LVIS_SELECTED)
		{
			CWnd::MessageBox("δѡ!","ʾ",MB_OK|MB_ICONEXCLAMATION);
		}
	}
	if(nItem == 0)
	{
		CWnd::MessageBox("Ѿ!","ʾ",MB_OK|MB_ICONEXCLAMATION);
	}

	if(nItem > 0)
	{
		LV_ITEM lvi;
		lvi.mask = LVIF_TEXT | LVIF_STATE;
		lvi.iItem = nItem-1;
		lvi.iSubItem = 0;
		lvi.pszText = "";
		CString temp = m_lstCol.GetItemText(nItem, 0);
		char* p = (LPSTR)(LPCSTR)temp;
		lvi.pszText = p;
		lvi.stateMask = LVIS_STATEIMAGEMASK;
		lvi.state = m_lstCol.GetItemState(nItem, LVIS_STATEIMAGEMASK);
		int ret = m_lstCol.InsertItem(&lvi);
		m_lstCol.SetItemText(ret, 0,lvi.pszText);
		CString szWidth;
		long lWidth = atol(m_lstCol.GetItemText(nItem+1, 1));
		szWidth.Format("%d",lWidth);
		m_lstCol.SetItemText(ret, 1,szWidth);
		m_lstCol.DeleteItem(nItem+1);
		m_lstCol.SetItemState(ret, LVIS_SELECTED, LVIS_SELECTED);
	}
}

void CGridPage::OnMovedown() 
{	
	CMainFrame* pFrmae = (CMainFrame*)g_pApp->m_pMainWnd;
	CEhhevtView* pView = pFrmae->GetView();
//	int nItem ;
	
	for(int i=0; i<m_lstCol.GetItemCount(); i++)
	{
		if(m_lstCol.GetItemState(i, LVIS_SELECTED) == LVIS_SELECTED)
		{	
			nItem=i;
			break;
		}
		if(i == m_lstCol.GetItemCount() - 1 && m_lstCol.GetItemState(i, LVIS_SELECTED) != LVIS_SELECTED)
		{
			CWnd::MessageBox("δѡ!","ʾ",MB_OK|MB_ICONEXCLAMATION);
		}
	}
	if(nItem == m_lstCol.GetItemCount()-1)
	{
		CWnd::MessageBox("Ѿһ!","ʾ",MB_OK|MB_ICONEXCLAMATION);
	}

	if(nItem >= 0)
	{
		LV_ITEM lvi;
		lvi.mask = LVIF_TEXT | LVIF_STATE;
		lvi.iItem = nItem+2;
		lvi.iSubItem = 0;
		lvi.pszText = "";
		CString temp = m_lstCol.GetItemText(nItem, 0);
		char* p = (LPSTR)(LPCSTR)temp;
		lvi.pszText = p;
		lvi.stateMask = LVIS_STATEIMAGEMASK;
		lvi.state = m_lstCol.GetItemState(nItem, LVIS_STATEIMAGEMASK);
		int ret = m_lstCol.InsertItem(&lvi);
		m_lstCol.SetItemText(ret, 0,lvi.pszText);
		CString szWidth;
		long lWidth = atol(m_lstCol.GetItemText(nItem, 1));
		szWidth.Format("%d",lWidth);
		m_lstCol.SetItemText(ret, 1,szWidth);
		m_lstCol.DeleteItem(nItem);
		m_lstCol.SetItemState(ret-1, LVIS_SELECTED, LVIS_SELECTED);
	}
}

void CGridPage::OnMovetotop()
{ 
	CMainFrame* pFrmae = (CMainFrame*)g_pApp->m_pMainWnd;
	CEhhevtView* pView = pFrmae->GetView();
//	int nItem ;
	
	for(int i=0; i<m_lstCol.GetItemCount(); i++)
	{
		if(m_lstCol.GetItemState(i, LVIS_SELECTED) == LVIS_SELECTED)
		{	
			nItem=i;
			break;
		}
		if(i == m_lstCol.GetItemCount() - 1 && m_lstCol.GetItemState(i, LVIS_SELECTED) != LVIS_SELECTED)
		{
			CWnd::MessageBox("δѡ!","ʾ",MB_OK|MB_ICONEXCLAMATION);
		}
	}
	if(nItem == 0)
	{
		CWnd::MessageBox("Ѿ!","ʾ",MB_OK|MB_ICONEXCLAMATION);
	}


	if(nItem > 0)
	{
		LV_ITEM lvi;
		lvi.mask = LVIF_TEXT | LVIF_STATE;
		lvi.iItem = 0;
		lvi.iSubItem = 0;
		lvi.pszText = "";
		CString temp = m_lstCol.GetItemText(nItem, 0);
		char* p = (LPSTR)(LPCSTR)temp;
		lvi.pszText = p;
		lvi.stateMask = LVIS_STATEIMAGEMASK;
		lvi.state = m_lstCol.GetItemState(nItem, LVIS_STATEIMAGEMASK);
		m_lstCol.InsertItem(&lvi);
		m_lstCol.SetItemText(0, 0,lvi.pszText);
		CString szWidth;
		long lWidth = atol(m_lstCol.GetItemText(nItem+1, 1));
		szWidth.Format("%d",lWidth);
		m_lstCol.SetItemText(0, 1,szWidth);
		m_lstCol.DeleteItem(nItem+1);
		m_lstCol.SetItemState(0, LVIS_SELECTED, LVIS_SELECTED);
	}
}

void CGridPage::OnMovetoend() 
{	
	CMainFrame* pFrmae = (CMainFrame*)g_pApp->m_pMainWnd;
	CEhhevtView* pView = pFrmae->GetView();
//	int nItem ;
	
	for(int i=0; i<m_lstCol.GetItemCount(); i++)
	{
		if(m_lstCol.GetItemState(i, LVIS_SELECTED) == LVIS_SELECTED)
		{	
			nItem=i;
			break;
		}
		if(i == m_lstCol.GetItemCount() - 1 && m_lstCol.GetItemState(i, LVIS_SELECTED) != LVIS_SELECTED)
		{
			CWnd::MessageBox("δѡ!","ʾ",MB_OK|MB_ICONEXCLAMATION);
		}
	}
	if(nItem == m_lstCol.GetItemCount()-1)
	{
		CWnd::MessageBox("Ѿһ!","ʾ",MB_OK|MB_ICONEXCLAMATION);
	}
	if(nItem >= 0)
	{
		LV_ITEM lvi;
		lvi.mask = LVIF_TEXT | LVIF_STATE;
		lvi.iItem = m_lstCol.GetItemCount()+2;
		lvi.iSubItem = 0;
		lvi.pszText = "";
		CString temp = m_lstCol.GetItemText(nItem, 0);
		char* p = (LPSTR)(LPCSTR)temp;
		lvi.pszText = p;
		lvi.stateMask = LVIS_STATEIMAGEMASK;
		lvi.state = m_lstCol.GetItemState(nItem, LVIS_STATEIMAGEMASK);
		m_lstCol.InsertItem(&lvi);
		m_lstCol.SetItemText(m_lstCol.GetItemCount()+2, 0,lvi.pszText);
		CString szWidth;
		long lWidth = atol(m_lstCol.GetItemText(nItem, 1));
		szWidth.Format("%d",lWidth);
		m_lstCol.SetItemText(m_lstCol.GetItemCount()-1, 1, szWidth);
		m_lstCol.DeleteItem(nItem);
		m_lstCol.SetItemState(m_lstCol.GetItemCount()-1, LVIS_SELECTED, LVIS_SELECTED);
	}
}

void CGridPage::OnDefault() 
{
	CSE_DBOption dbo;
    if (dbo.BeginSelectRcdSet(SQL_ALMH_FLD) == SEDB_SUCCESS)   
	{
		CReadConf cfg;
		CEhhevtApp *pApp =(CEhhevtApp *)AfxGetApp();
		m_lstCol.DeleteAllItems( );
		int nCol = m_pDlg->m_nCols;
		LV_ITEM lvi;
		lvi.mask = LVIF_TEXT | LVIF_STATE;
		for(int i = 0; i < nCol; i++)
		{
			lvi.iItem = i;
			lvi.iSubItem = 0;
			char szName[32];
			strcpy(szName, dbo.GetStringVal(i, 0));
			lvi.pszText = szName;
			lvi.stateMask = LVIS_STATEIMAGEMASK;
			lvi.state = INDEXTOSTATEIMAGEMASK(2);
			m_lstCol.InsertItem(&lvi);
			short datalen = dbo.GetShortVal(i, 1);
			char szWidth[MAX_PATH];
			char width[10];
			sprintf(szWidth, "%s", szName);
			sprintf(width, "%d", datalen > 0 ? min(datalen, 64) * 8 : 64);
			long lWidth = cfg.ReadLong("History", szWidth, pApp->m_szCfgPath, width);

			CString sz;
			sz.Format("%d", lWidth);
			m_lstCol.SetItemText(i, 1, sz);
		}
	}
	dbo.EndSelectRcdSet();
}

void CGridPage::OnUpdateMoveup(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
}

void CGridPage::OnUpdateMovetotop(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
}

void CGridPage::OnUpdateMovedown(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
}

void CGridPage::OnUpdateMovetoend(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
}
