// MainFrm.h : interface of the CMainFrame class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MAINFRM_H__CE1830F0_90F5_49C3_93BA_DBF2FFE93E7B__INCLUDED_)
#define AFX_MAINFRM_H__CE1830F0_90F5_49C3_93BA_DBF2FFE93E7B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include "CMyTabCtrlBar.h"
#include "EhhevtView.h"
#include "ToolView.h"
#include "BtmToolBar.h"
//#include "CommonDef.h"

class CMainFrame : public CFrameWnd
{

protected: // create from serialization only
	CMainFrame();
	DECLARE_DYNCREATE(CMainFrame)
	enum { FIRST, PREVIOUS, NEXT, LAST , SKIP};
// Attributes
public:
	int m_nCols ;
	int m_nRows ;

//	CArray<ALMPRI, ALMPRI&> m_priType;
// Operations
public:
    CList<long, long> m_DelList;
	CSE_DBOption m_dbOption;
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMainFrame)
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL
    CReBar	m_wndReBar;        //Rebar
	CMyTabCtrlBar m_wndWorkspace;
	CImageList m_ImageList;

// Implementation
public:
	void SendAlarm(int Val,CString DevKey);
	void SetToolBarShow();
	void SetToolBarHide();
	CToolView* GetExView();
	CEhhevtView* GetView();
	void SetcolNum(int val);
	void SetPageNum(int nCurrPage, int nTotalPage);
	BOOL CreateExToolBar();
	virtual ~CMainFrame();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:  // control bar embedded members
	CStatusBar  m_wndStatusBar;
	CToolBar    m_wndToolBar;
	CBtmToolBar m_btmToolBar;
  
// Generated message map functions
protected:
	//{{AFX_MSG(CMainFrame)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnPrint(); 
    afx_msg void OnUpdatePrint(CCmdUI* pCmdUI);
    afx_msg void OnAdd(); 
    afx_msg void OnUpdateAdd(CCmdUI* pCmdUI);
    afx_msg void OnModify(); 
    afx_msg void OnUpdateModify(CCmdUI* pCmdUI);
	afx_msg void OnSet(); 
    afx_msg void OnUpdateSet(CCmdUI* pCmdUI);
    afx_msg void OnDel(); 
    afx_msg void OnUpdateDel(CCmdUI* pCmdUI);
    afx_msg void OnHelp(); 
    afx_msg void OnUpdateHelp(CCmdUI* pCmdUI);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnReport();
    afx_msg void OnFirst(); 
    afx_msg void OnUpdateFirst(CCmdUI* pCmdUI);
    afx_msg void OnPre(); 
    afx_msg void OnUpdatePre(CCmdUI* pCmdUI);
    afx_msg void OnNext(); 
    afx_msg void OnUpdateNext(CCmdUI* pCmdUI);
    afx_msg void OnLast(); 
    afx_msg void OnUpdateLast(CCmdUI* pCmdUI);
	afx_msg void OnSkip(); 
    afx_msg void OnUpdateSkip(CCmdUI* pCmdUI);
	afx_msg void OnBtnSave();
	afx_msg void OnBtnSave2();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
protected:
	BOOL WriteToExcel(CEhhevtView* pView, CString &csStrFile);
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAINFRM_H__CE1830F0_90F5_49C3_93BA_DBF2FFE93E7B__INCLUDED_)
