// ReportDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Ehhevt.h"
#include "ReportDlg.h"

#include "cell2000.cpp"

#include "EhhevtView.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

const char * const ModelName = "ʷ";
const int Border = 16;

/////////////////////////////////////////////////////////////////////////////
// CReportDlg dialog


CReportDlg::CReportDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CReportDlg::IDD, pParent), m_pFrame((CMainFrame *)pParent)
{
	//{{AFX_DATA_INIT(CReportDlg)
	//}}AFX_DATA_INIT
}


void CReportDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CReportDlg)
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CReportDlg, CDialog)
	//{{AFX_MSG_MAP(CReportDlg)
	ON_BN_CLICKED(IDC_PRINT, OnPrint)
	ON_BN_CLICKED(IDC_PRINTVIEW, OnPrintview)
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CReportDlg message handlers

BOOL CReportDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	InitCell();

	InitData();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CReportDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);

	if (::IsWindow(m_cellopt.m_ctrl.GetSafeHwnd()))
	{
		CRect rcBtn;
		GetDlgItem(IDOK)->GetWindowRect(rcBtn);

		CRect rc(
			cx - Border * 2 - rcBtn.Width(),
			cy - Border - rcBtn.Height(),
			cx - Border * 2,
			cy - Border
			);

		GetDlgItem(IDOK)->MoveWindow(rc);

		rc.right = rc.left - Border * 2;
		rc.left  = rc.right - rcBtn.Width();
		GetDlgItem(IDC_PRINTVIEW)->MoveWindow(rc);

		rc.right = rc.left - Border * 2;
		rc.left  = rc.right - rcBtn.Width();
		GetDlgItem(IDC_PRINT)->MoveWindow(rc);

		m_cellopt.m_ctrl.MoveWindow(Border, Border, cx - Border * 2, rc.top - Border - 5);
	}
}

void CReportDlg::OnPrint() 
{
	m_cellopt.OnFilePrint();
}

void CReportDlg::OnPrintview() 
{
	m_cellopt.OnFilePrintpreview();
}

BOOL CReportDlg::InitData()
{
	m_cellopt.m_nCtrlType=1;

	m_cellopt.ActiveSheetByLable(1, "ʷ", ModelName);

	BOOL bModel = FALSE;

	MODEL_INFO MdInfo;
	for (int i=0; i < m_cellopt.m_arrMdInfo.GetSize(); i++)
	{
		MdInfo = m_cellopt.m_arrMdInfo.GetAt(i);
		if (strcmp(MdInfo.ModelName, ModelName) == 0)
		{
			bModel = TRUE;
			break;
		}
	}

	if (!bModel)
		return FALSE;

	int nSheet = m_cellopt.m_ctrl.GetCurSheet();
	m_cellopt.m_ctrl.CopyRange(MdInfo.Copy_SCol,MdInfo.Copy_SRow,MdInfo.Copy_ECol,MdInfo.Copy_ERow);

	CString recno;

    CGridCtrl *pGridCtrl = m_pFrame->GetView()->m_pGridCtrl;
	if (!::IsWindow(pGridCtrl->GetSafeHwnd()))
		return FALSE;

	int rcdcount = pGridCtrl->GetRowCount();
	for (i=0; i < rcdcount; i++)
	{
		if (i > 0)
		{
			m_cellopt.m_ctrl.InsertRow(MdInfo.Copy_SRow+i,MdInfo.Copy_ERow-MdInfo.Copy_SRow+1,nSheet);
			m_cellopt.m_ctrl.Paste(MdInfo.Copy_SCol,MdInfo.Copy_SRow+i,0,1,1);

			recno.Format("%d", i);
			m_cellopt.m_ctrl.S(MdInfo.Copy_SCol + 0, MdInfo.Copy_SRow + i - 1, nSheet, recno);
		}

		for (int j=1; j < pGridCtrl->GetColumnCount(); j++)
		{
			m_cellopt.m_ctrl.S(MdInfo.Copy_SCol + j, MdInfo.Copy_SRow + i - 1, nSheet, pGridCtrl->GetItemText(i, j));
		}
	}

	return TRUE;
}

BOOL CReportDlg::InitCell()
{
	CRect rcWnd;
	GetClientRect(rcWnd);

	CRect rcBtn;
	GetDlgItem(IDOK)->GetWindowRect(rcBtn);
	ScreenToClient(rcBtn);

	CRect rc(Border, Border, rcWnd.right - Border, rcBtn.top - 5);

	if (m_cellopt.CreateCellCtrl(this, rc, WS_CHILD | WS_VISIBLE, 1000) == 0)
		return FALSE;

	CString strPath;

	char * home = getenv("SEROOT");
	if (home)
		strPath.Format("%s\\report\\MReport", home);
	else
		strPath.Format(".\\MReport");

	m_cellopt.InitCellFile(strPath);

	m_cellopt.LoadCellFile(0, "ʷ", ModelName);

	return TRUE;
}
